<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}" xmlns:sd="http://www.w3.org/1999/xhtml">
<head>
    <meta charset="UTF-8">
    <title>Journal Template</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_setting::sidebar_setting" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Journal Template</h5>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-12 text-end mb-3">
                                <button class="btn btn-success btn-sm" data-bs-toggle="modal" data-bs-target="#addJournalTemplate">
                                    <i class="fa fa-plus-circle"></i>&nbsp; Add Journal Template
                                </button>
                                <div class="modal fade" id="addJournalTemplate" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                    <div class="modal-dialog">
                                        <form th:action="@{/journal-template/save}" method="post">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h1 class="modal-title fs-5" id="exampleModalLabel">Create Journal Template</h1>
                                                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-body text-start">
                                                    <div class="form-group mb-2">
                                                        <label for="code">Code</label>
                                                        <input type="text" onkeyup="checkCode(this)" onchange="checkCode(this)" class="form-control" name="code" id="code" required>
                                                        <span style="display: none; color: red" id="validateCode">* the code has already been used</span>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label for="name">Name</label>
                                                        <input type="text" class="form-control" name="name" id="name" required>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label for="category">Category</label>
                                                        <select name="journalCategoryTemplate" class="form-control" id="category" required>
                                                            <option value="" selected>Choose one</option>
                                                            <option th:each="data, row:${listCategory}"
                                                                    th:text="${data.category}"
                                                                    th:value="${data.id}"></option>
                                                        </select>
                                                    </div>

                                                    <div class="form-group mb-2">
                                                        <label for="typeApp">Application</label>
                                                        <select name="typeApp" id="typeApp" class="form-select">
                                                            <option value="">-- Pilih Salah Aplikasi --</option>
                                                            <option th:each="data : ${typeApp}"
                                                                    th:value="${data}" th:text="${data}"></option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                                                    <button type="submit" id="btnSubmit" class="btn btn-primary">Save</button>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <form action="" method="get">
                            <form action="">
                                <div class="row mb-3">
                                    <div class="col-md-6">
                                        <select name="typeApp" id="" class="form-control">
                                            <option value="">-- Pilih Aplikasi --</option>
                                            <option th:each="data : ${typeApp}"
                                                    th:value="${data}" th:text="${data}"></option>
                                        </select>
                                    </div>
                                    <div class="col-md-6 text-end">
                                        <div class="input-group mb-3">
                                            <input type="text" class="form-control" placeholder="Search by code or name" aria-label="Search" name="search" aria-describedby="button-addon2">
                                            <button class="btn btn-secondary" type="submit" id="button-addon2">Search</button>
                                        </div>
                                    </div>
                                </div>
                            </form>

                        </form>

                        <div class="row">
                            <div class="col-md-12">
                                <div class="alert alert-success alert-dismissible fade show" role="alert" th:if="${success != null}">
                                    <strong th:text="${success}"></strong>
                                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                </div>
                                <div class="alert alert-danger alert-dismissible fade show" role="alert" th:if="${error != null}">
                                    <strong th:text="${error}"></strong>
                                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                </div>
                            </div>
                        </div>
                        <div class="table-responsive">
                            <table class="table table-bordered">
                                <thead class="table-dark" style="--bs-table-bg: #0a3e8a">
                                <tr>
                                    <th>#</th>
                                    <th>Code</th>
                                    <th>Name</th>
                                    <th>Category</th>
                                    <th>Aplikasi</th>
                                    <th>Detail</th>
                                    <th></th>
                                </tr>
                                </thead>
                                <tbody th:each="data, row:${listJournalTemplate}">
                                <tr class="bg-secondary bg-opacity-25">
                                    <td th:text="${(row.index + 1)}"></td>
                                    <td th:text="${data.code}"></td>
                                    <td th:text="${data.name}"></td>
                                    <td th:text="${data.journalCategoryTemplate.category}"></td>
                                    <td th:text="${data.typeApp}"></td>
                                    <td>
                                        <a th:href="@{/journal-template/detail(journalTemplate = ${data.id})}" class="btn btn-primary btn-sm">
                                            <i class="fa fa-plus-circle"></i> Add Detail
                                        </a>
                                    </td>
                                    <td>
                                        <a th:href="@{/journal-template/edit(journalTemplate = ${data.id})}" class="btn btn-info btn-sm"><i class="fa fa-edit text-white"></i></a>
                                        <a th:href="@{/journal-template/delete(id = ${data.id})}"
                                           onclick="return confirm('Apakah Anda yakin ingin menghapus data ini ?');"
                                           class="btn btn-danger btn-sm">
                                            <i class="fa fa-trash"></i>
                                        </a>
                                    </td>
                                </tr>
                                <tr class="bg-secondary bg-opacity-10">
                                    <th></th>
                                    <th>Sequence</th>
                                    <th>Code</th>
                                    <th>Name</th>
                                    <th>Balance Type</th>
                                    <th colspan="2"></th>
                                </tr>
                                <tr th:each="dataDetail, row:${listDetailJournalTemplate}" th:if="${dataDetail.journalTemplate.id == data.id}">
                                    <td></td>
                                    <td th:text="${dataDetail.sequence}"></td>
                                    <td th:text="${dataDetail.account.code}"></td>
                                    <td th:text="${dataDetail.account.name}"></td>
                                    <td>
                                        <span th:text="${dataDetail.balanceType}" th:if="${dataDetail.balanceType.toString() == 'DEBET'}" class="badge text-bg-success"></span>
                                        <span th:text="${dataDetail.balanceType}" th:if="${dataDetail.balanceType.toString() == 'CREDIT'}" class="badge text-bg-warning"></span>
                                    </td>
                                    <td colspan="2">
                                        <a th:href="@{/journal-template/detail/delete(id = ${dataDetail.id})}"
                                           onclick="return confirm('Apakah Anda yakin ingin menghapus data ini ?');"
                                           class="text-danger">
                                            Delete
                                        </a>
                                    </td>
                                </tr>
                                <tr th:each="dataValidation, row:${journalValidation}" th:if="${data.id == dataValidation[0]}">
                                    <td colspan="7" style="text-align: center;">
                                        <div class="alert alert-danger" role="alert" th:if="${dataValidation[2] < 2}">
                                            Dalam suatu template jurnal, disarankan untuk memiliki minimal dua atau lebih
                                            rincian template jurnal, dengan keharusan mencakup transaksi debet dan kredit.
                                        </div>
                                        <div class="alert alert-danger" role="alert" th:if="${dataValidation[3] < 1}">
                                            Belum ada catatan debet.
                                        </div>
                                        <div class="alert alert-danger" role="alert" th:if="${dataValidation[4] < 1}">
                                            Belum ada catatan credit.
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                        <nav aria-label="Page navigation example">
                            <ul class="pagination justify-content-center" sd:pagination="full">
                                <li class="page-item disabled">
                                    <a class="page-link" href="#" tabindex="-1">Previous</a>
                                </li>
                                <li class="page-item"><a class="page-link" href="#">1</a></li>
                                <li class="page-item"><a class="page-link" href="#">2</a></li>
                                <li class="page-item"><a class="page-link" href="#">3</a></li>
                                <li class="page-item">
                                    <a class="page-link" href="#">Next</a>
                                </li>
                            </ul>
                        </nav>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>

        var delay = (function () {
            var timer = 0;
            return function (callback, ms) {
                clearTimeout(timer);
                timer = setTimeout(callback, ms);
            };
        })();

        function checkCode(arg) {
            var value = arg.value;

            $(document).keyup(function (e) {
                delay(function () {
                    var url = "/api/check/journal-template?code="+value;
                    $.getJSON(url, function (data) {
                        if (data.code == 'FORBIDDEN'){
                            document.getElementById("validateCode").style.display = "block";
                            document.getElementById("btnSubmit").disabled = true;
                            console.log(data.message)
                        }else {
                            document.getElementById("validateCode").style.display = "none";
                            document.getElementById("btnSubmit").disabled = false;
                            console.log(data.message)
                        }
                    })

                }, 800);

            });
        }

    </script>
</div>
</body>
</html>